Gentoo Archives: gentoo-commits

From: Nick Sarnie <sarnex@g.o>
To: gentoo-commits@l.g.o
Subject: [gentoo-commits] repo/proj/wine:master commit in: app-emulation/wine-vanilla/
Date: Thu, 24 Jan 2019 02:38:30
Message-Id: 1548297151.2a9526645686edc4a6214b7f591628f170043c2a.sarnex@gentoo
1 commit: 2a9526645686edc4a6214b7f591628f170043c2a
2 Author: Nick Sarnie <sarnex <AT> gentoo <DOT> org>
3 AuthorDate: Thu Jan 24 02:32:31 2019 +0000
4 Commit: Nick Sarnie <sarnex <AT> gentoo <DOT> org>
5 CommitDate: Thu Jan 24 02:32:31 2019 +0000
6 URL: https://gitweb.gentoo.org/repo/proj/wine.git/commit/?id=2a952664
7
8 app-emulation/wine-vanilla: Bump to 4.0
9
10 Package-Manager: Portage-2.3.58, Repoman-2.3.12
11 Signed-off-by: Nick Sarnie <sarnex <AT> gentoo.org>
12
13 app-emulation/wine-vanilla/Manifest | 1 +
14 app-emulation/wine-vanilla/wine-vanilla-4.0.ebuild | 533 +++++++++++++++++++++
15 2 files changed, 534 insertions(+)
16
17 diff --git a/app-emulation/wine-vanilla/Manifest b/app-emulation/wine-vanilla/Manifest
18 index 50aa21d..3a160af 100644
19 --- a/app-emulation/wine-vanilla/Manifest
20 +++ b/app-emulation/wine-vanilla/Manifest
21 @@ -52,3 +52,4 @@ DIST wine-3.6.tar.xz 20005240 BLAKE2B 6dd48180b9aed8a3b69c40b3ed7b2ff5adbebfb591
22 DIST wine-3.7.tar.xz 20454036 BLAKE2B 04ac94d5679377c5d0bb37a6d3e8e3ec7c09faa300f8422a09a22b14ef4244d2bb14c80a47cfca5e11526506a8064f0cfa4e28868d7f04669f85ab743dbbb36d SHA512 a699418574dd8f407c064421cf6cdfe3923562c8adf9a7749e716f3853291eab05358ea64f0217c303c26c0f8f59d2116024b7b6978f9a52a055147e689a8694
23 DIST wine-3.8.tar.xz 20473392 BLAKE2B a7873dd15a373491703e16888044cf2ba00121f91a4583fe6dcf687b5179a2d926035cc86c75f70ceca03a508bd4712c58a1662186e0a6e0c139e63e686f8c5d SHA512 387c6bff3eafac7e92030d11c02b3461b4ead059d2aad7f6d903e176f304d2ac0a426132fcd452507868f0d22bb360a30734edf3e73dfd514037458f08406e98
24 DIST wine-3.9.tar.xz 20508952 BLAKE2B 6fbf22673588963c483b7b31e82287c09e15b579b8f57267e2731768f95a1f986954bb473ee0dfa2428802fe9331b8599a01c782dd1152d36ce2002b6a4e6bde SHA512 4c4e5a741a61b9427c175e015177df5806638736f7dfd92098ed95239d41a373cbab876c054d3c948e1db6a7de359db3babd63bc194edc8c2c3be28b58f75e64
25 +DIST wine-4.0.tar.xz 21644692 BLAKE2B 9c426ef2249c16e908a3617c2844d8b12a2df843721338b1cfb69459815b902cfa0ddf3d74c09dc900fb2ceb003e54d97a7c0afaac51a9caab7d21beb82e26c3 SHA512 7607fa7a3d5f7bcd3d8c4c9e7bb6e1987466110bbfc672782ebe57c6d9da348c58e76abf40b0a70c725dfd703163db6e194ee0e3db11a47b6b60e225163308dd
26
27 diff --git a/app-emulation/wine-vanilla/wine-vanilla-4.0.ebuild b/app-emulation/wine-vanilla/wine-vanilla-4.0.ebuild
28 new file mode 100644
29 index 0000000..416e5ed
30 --- /dev/null
31 +++ b/app-emulation/wine-vanilla/wine-vanilla-4.0.ebuild
32 @@ -0,0 +1,533 @@
33 +# Copyright 1999-2019 Gentoo Authors
34 +# Distributed under the terms of the GNU General Public License v2
35 +
36 +EAPI=6
37 +
38 +PLOCALES="ar bg ca cs da de el en en_US eo es fa fi fr he hi hr hu it ja ko lt ml nb_NO nl or pa pl pt_BR pt_PT rm ro ru sk sl sr_RS@cyrillic sr_RS@latin sv te th tr uk wa zh_CN zh_TW"
39 +PLOCALE_BACKUP="en"
40 +
41 +inherit autotools eapi7-ver estack eutils flag-o-matic gnome2-utils l10n multilib multilib-minimal pax-utils toolchain-funcs virtualx xdg-utils
42 +
43 +MY_PN="${PN%%-*}"
44 +MY_P="${MY_PN}-${PV}"
45 +
46 +if [[ ${PV} == "9999" ]] ; then
47 + EGIT_REPO_URI="https://source.winehq.org/git/wine.git"
48 + EGIT_BRANCH="master"
49 + inherit git-r3
50 + SRC_URI=""
51 + #KEYWORDS=""
52 +else
53 + MAJOR_V=$(ver_cut 1)
54 + MINOR_V=$(ver_cut 2)
55 + SRC_URI="https://dl.winehq.org/wine/source/${MAJOR_V}.${MINOR_V}/${MY_P}.tar.xz"
56 + KEYWORDS="-* ~amd64 ~x86 ~x86-fbsd"
57 +fi
58 +S="${WORKDIR}/${MY_P}"
59 +
60 +GWP_V="20180120"
61 +PATCHDIR="${WORKDIR}/gentoo-wine-patches"
62 +
63 +DESCRIPTION="Free implementation of Windows(tm) on Unix, without external patchsets"
64 +HOMEPAGE="https://www.winehq.org/"
65 +SRC_URI="${SRC_URI}
66 + https://dev.gentoo.org/~np-hardass/distfiles/wine/gentoo-wine-patches-${GWP_V}.tar.xz
67 +"
68 +
69 +LICENSE="LGPL-2.1"
70 +SLOT="${PV}"
71 +IUSE="+abi_x86_32 +abi_x86_64 +alsa capi cups custom-cflags dos elibc_glibc +fontconfig +gecko gphoto2 gsm gssapi gstreamer +jpeg kerberos kernel_FreeBSD +lcms ldap +mono mp3 ncurses netapi nls odbc openal opencl +opengl osmesa oss +perl pcap +png prelink pulseaudio +realtime +run-exes samba scanner sdl selinux +ssl test +threads +truetype udev +udisks v4l vkd3d vulkan +X +xcomposite xinerama +xml"
72 +REQUIRED_USE="|| ( abi_x86_32 abi_x86_64 )
73 + X? ( truetype )
74 + elibc_glibc? ( threads )
75 + osmesa? ( opengl )
76 + test? ( abi_x86_32 )
77 + vkd3d? ( vulkan )" # osmesa-opengl #286560 # X-truetype #551124
78 +
79 +# FIXME: the test suite is unsuitable for us; many tests require net access
80 +# or fail due to Xvfb's opengl limitations.
81 +RESTRICT="test"
82 +
83 +COMMON_DEPEND="
84 + X? (
85 + x11-libs/libXcursor[${MULTILIB_USEDEP}]
86 + x11-libs/libXext[${MULTILIB_USEDEP}]
87 + x11-libs/libXfixes[${MULTILIB_USEDEP}]
88 + x11-libs/libXrandr[${MULTILIB_USEDEP}]
89 + x11-libs/libXi[${MULTILIB_USEDEP}]
90 + x11-libs/libXxf86vm[${MULTILIB_USEDEP}]
91 + )
92 + alsa? ( media-libs/alsa-lib[${MULTILIB_USEDEP}] )
93 + capi? ( net-libs/libcapi[${MULTILIB_USEDEP}] )
94 + cups? ( net-print/cups:=[${MULTILIB_USEDEP}] )
95 + fontconfig? ( media-libs/fontconfig:=[${MULTILIB_USEDEP}] )
96 + gphoto2? ( media-libs/libgphoto2:=[${MULTILIB_USEDEP}] )
97 + gsm? ( media-sound/gsm:=[${MULTILIB_USEDEP}] )
98 + gssapi? ( virtual/krb5[${MULTILIB_USEDEP}] )
99 + gstreamer? (
100 + media-libs/gstreamer:1.0[${MULTILIB_USEDEP}]
101 + media-plugins/gst-plugins-meta:1.0[${MULTILIB_USEDEP}]
102 + )
103 + jpeg? ( virtual/jpeg:0=[${MULTILIB_USEDEP}] )
104 + kerberos? ( virtual/krb5[${MULTILIB_USEDEP}] )
105 + lcms? ( media-libs/lcms:2=[${MULTILIB_USEDEP}] )
106 + ldap? ( net-nds/openldap:=[${MULTILIB_USEDEP}] )
107 + mp3? ( >=media-sound/mpg123-1.5.0[${MULTILIB_USEDEP}] )
108 + ncurses? ( >=sys-libs/ncurses-5.2:0=[${MULTILIB_USEDEP}] )
109 + netapi? ( net-fs/samba[netapi(+),${MULTILIB_USEDEP}] )
110 + nls? ( sys-devel/gettext[${MULTILIB_USEDEP}] )
111 + odbc? ( dev-db/unixODBC:=[${MULTILIB_USEDEP}] )
112 + openal? ( media-libs/openal:=[${MULTILIB_USEDEP}] )
113 + opencl? ( virtual/opencl[${MULTILIB_USEDEP}] )
114 + opengl? (
115 + virtual/glu[${MULTILIB_USEDEP}]
116 + virtual/opengl[${MULTILIB_USEDEP}]
117 + )
118 + osmesa? ( >=media-libs/mesa-13[osmesa,${MULTILIB_USEDEP}] )
119 + pcap? ( net-libs/libpcap[${MULTILIB_USEDEP}] )
120 + png? ( media-libs/libpng:0=[${MULTILIB_USEDEP}] )
121 + pulseaudio? ( media-sound/pulseaudio[${MULTILIB_USEDEP}] )
122 + scanner? ( media-gfx/sane-backends:=[${MULTILIB_USEDEP}] )
123 + sdl? ( media-libs/libsdl2:=[haptic,joystick,${MULTILIB_USEDEP}] )
124 + ssl? ( net-libs/gnutls:=[${MULTILIB_USEDEP}] )
125 + truetype? ( >=media-libs/freetype-2.0.0[${MULTILIB_USEDEP}] )
126 + udev? ( virtual/libudev:=[${MULTILIB_USEDEP}] )
127 + udisks? ( sys-apps/dbus[${MULTILIB_USEDEP}] )
128 + v4l? ( media-libs/libv4l[${MULTILIB_USEDEP}] )
129 + vkd3d? ( app-emulation/vkd3d[${MULTILIB_USEDEP}] )
130 + vulkan? ( media-libs/vulkan-loader[${MULTILIB_USEDEP}] )
131 + xcomposite? ( x11-libs/libXcomposite[${MULTILIB_USEDEP}] )
132 + xinerama? ( x11-libs/libXinerama[${MULTILIB_USEDEP}] )
133 + xml? (
134 + dev-libs/libxml2[${MULTILIB_USEDEP}]
135 + dev-libs/libxslt[${MULTILIB_USEDEP}]
136 + )"
137 +
138 +RDEPEND="${COMMON_DEPEND}
139 + app-emulation/wine-desktop-common
140 + >app-eselect/eselect-wine-0.3
141 + !app-emulation/wine:0
142 + dos? ( >=games-emulation/dosbox-0.74_p20160629 )
143 + gecko? ( app-emulation/wine-gecko:2.47[abi_x86_32?,abi_x86_64?] )
144 + mono? ( app-emulation/wine-mono:4.7.3 )
145 + perl? (
146 + dev-lang/perl
147 + dev-perl/XML-Simple
148 + )
149 + pulseaudio? (
150 + realtime? ( sys-auth/rtkit )
151 + )
152 + samba? ( >=net-fs/samba-3.0.25[winbind] )
153 + selinux? ( sec-policy/selinux-wine )
154 + udisks? ( sys-fs/udisks:2 )"
155 +
156 +# tools/make_requests requires perl
157 +DEPEND="${COMMON_DEPEND}
158 + sys-devel/flex
159 + >=sys-kernel/linux-headers-2.6
160 + virtual/pkgconfig
161 + virtual/yacc
162 + X? ( x11-base/xorg-proto )
163 + prelink? ( sys-devel/prelink )
164 + xinerama? ( x11-base/xorg-proto )"
165 +
166 +# These use a non-standard "Wine" category, which is provided by
167 +# /etc/xdg/applications-merged/wine.menu
168 +QA_DESKTOP_FILE="usr/share/applications/wine-browsedrive.desktop
169 +usr/share/applications/wine-notepad.desktop
170 +usr/share/applications/wine-uninstaller.desktop
171 +usr/share/applications/wine-winecfg.desktop"
172 +
173 +PATCHES=(
174 + "${PATCHDIR}/patches/${MY_PN}-1.5.26-winegcc.patch" #260726
175 + "${PATCHDIR}/patches/${MY_PN}-1.9.5-multilib-portage.patch" #395615
176 + "${PATCHDIR}/patches/${MY_PN}-1.6-memset-O3.patch" #480508
177 + "${PATCHDIR}/patches/${MY_PN}-2.0-multislot-apploader.patch" #310611
178 +)
179 +PATCHES_BIN=()
180 +
181 +# https://bugs.gentoo.org/show_bug.cgi?id=635222
182 +if [[ ${#PATCHES_BIN[@]} -ge 1 ]] || [[ ${PV} == 9999 ]]; then
183 + DEPEND+=" dev-util/patchbin"
184 +fi
185 +
186 +wine_compiler_check() {
187 + [[ ${MERGE_TYPE} = "binary" ]] && return 0
188 +
189 + # GCC-specific bugs
190 + if tc-is-gcc; then
191 + # bug #549768
192 + if use abi_x86_64 && [[ $(gcc-major-version) = 5 && $(gcc-minor-version) -le 2 ]]; then
193 + ebegin "Checking for gcc-5 ms_abi compiler bug"
194 + $(tc-getCC) -O2 "${PATCHDIR}/files/pr66838.c" -o "${T}"/pr66838 || die
195 + # Run in subshell to prevent "Aborted" message
196 + ( "${T}"/pr66838 || false ) >/dev/null 2>&1
197 + if ! eend $?; then
198 + eerror "64-bit wine cannot be built with gcc-5.1 or initial patchset of 5.2.0"
199 + eerror "due to compiler bugs; please re-emerge the latest gcc-5.2.x ebuild,"
200 + eerror "or use gcc-config to select a different compiler version."
201 + eerror "See https://bugs.gentoo.org/549768"
202 + eerror
203 + return 1
204 + fi
205 + fi
206 + # bug #574044
207 + if use abi_x86_64 && [[ $(gcc-major-version) = 5 && $(gcc-minor-version) = 3 ]]; then
208 + ebegin "Checking for gcc-5-3 stack realignment compiler bug"
209 + # Compile in subshell to prevent "Aborted" message
210 + ( $(tc-getCC) -O2 -mincoming-stack-boundary=3 "${PATCHDIR}/files/pr69140.c" -o "${T}"/pr69140 ) >/dev/null 2>&1
211 + if ! eend $?; then
212 + eerror "Wine cannot be built with this version of gcc-5.3"
213 + eerror "due to compiler bugs; please re-emerge the latest gcc-5.3.x ebuild,"
214 + eerror "or use gcc-config to select a different compiler version."
215 + eerror "See https://bugs.gentoo.org/574044"
216 + eerror
217 + return 1
218 + fi
219 + fi
220 + fi
221 +
222 + # Ensure compiler support
223 + if use abi_x86_64; then
224 + ebegin "Checking for 64-bit compiler with builtin_ms_va_list support"
225 + # Compile in subshell to prevent "Aborted" message
226 + ( $(tc-getCC) -O2 "${PATCHDIR}/files/builtin_ms_va_list.c" -o "${T}"/builtin_ms_va_list >/dev/null 2>&1)
227 + if ! eend $?; then
228 + eerror "This version of $(tc-getCC) does not support builtin_ms_va_list, can't enable 64-bit wine"
229 + eerror
230 + eerror "You need gcc-4.4+ or clang 3.8+ to build 64-bit wine"
231 + eerror
232 + return 1
233 + fi
234 + fi
235 +}
236 +
237 +wine_build_environment_check() {
238 + [[ ${MERGE_TYPE} = "binary" ]] && return 0
239 +
240 + if use abi_x86_64; then
241 + if tc-is-gcc && [[ $(gcc-major-version) -lt 4 || ( $(gcc-major-version) -eq 4 && $(gcc-minor-version) -lt 4 ) ]]; then
242 + eerror "You need gcc-4.4+ to compile 64-bit wine"
243 + die
244 + elif tc-is-clang && [[ $(clang-major-version) -lt 3 || ( $(clang-major-version) -eq 3 && $(clang-minor-version) -lt 8 ) ]]; then
245 + eerror "You need clang-3.8+ to compile 64-bit wine"
246 + die
247 + fi
248 + fi
249 + if tc-is-gcc && [[ $(gcc-major-version) -eq 5 && $(gcc-minor-version) -le 3 ]]; then
250 + ewarn "GCC-5.0-5.3 suffered from compiler bugs and are no longer supported by"
251 + ewarn "Gentoo's Toolchain Team. If your ebuild fails the compiler checks in"
252 + ewarn "the configure phase, either update your compiler or switch to <5.0 || >=5.4"
253 + fi
254 + if tc-is-gcc && [[ $(gcc-major-version) -eq 5 && $(gcc-minor-version) -eq 4 ]]; then
255 + if has "-march=i686" ${CFLAGS} && ! has "-mtune=generic" ${CFLAGS}; then
256 + ewarn "Compilation can hang with CFLAGS=\"-march=i686\". You can temporarily work"
257 + ewarn "around this by adding \"-mtune=generic\" to your CFLAGS for wine."
258 + ewarn "See package.env in man 5 portage for more information on how to do this."
259 + ewarn "See https://bugs.gentoo.org/show_bug.cgi?id=613128 for more details"
260 + fi
261 + fi
262 +
263 + if use abi_x86_32 && use opencl && [[ "$(eselect opencl show 2> /dev/null)" == "intel" ]]; then
264 + eerror "You cannot build wine with USE=opencl because intel-ocl-sdk is 64-bit only."
265 + eerror "See https://bugs.gentoo.org/487864 for more details."
266 + eerror
267 + return 1
268 + fi
269 +}
270 +
271 +wine_env_vcs_vars() {
272 + local pn_live_var="${PN//[-+]/_}_LIVE_COMMIT"
273 + local pn_live_val="${pn_live_var}"
274 + eval pn_live_val='$'${pn_live_val}
275 + if [[ ! -z ${EGIT_COMMIT} ]]; then
276 + eerror "Commits must now be specified using the environmental variables"
277 + eerror "EGIT_OVERRIDE_COMMIT_WINE"
278 + eerror
279 + return 1
280 + fi
281 +}
282 +
283 +pkg_pretend() {
284 + wine_build_environment_check || die
285 +
286 + # Verify OSS support
287 + if use oss && ! use kernel_FreeBSD; then
288 + if ! has_version ">=media-sound/oss-4"; then
289 + eerror "You cannot build wine with USE=oss without having support from a"
290 + eerror "FreeBSD kernel or >=media-sound/oss-4 (only available through external repos)"
291 + eerror
292 + die
293 + fi
294 + fi
295 +}
296 +
297 +pkg_setup() {
298 + wine_build_environment_check || die
299 + wine_env_vcs_vars || die
300 +
301 + WINE_VARIANT="${PN#wine}-${PV}"
302 + WINE_VARIANT="${WINE_VARIANT#-}"
303 +
304 + MY_PREFIX="${EPREFIX}/usr/lib/wine-${WINE_VARIANT}"
305 + MY_DATAROOTDIR="${EPREFIX}/usr/share/wine-${WINE_VARIANT}"
306 + MY_DATADIR="${MY_DATAROOTDIR}"
307 + MY_DOCDIR="${EPREFIX}/usr/share/doc/${PF}"
308 + MY_INCLUDEDIR="${EPREFIX}/usr/include/wine-${WINE_VARIANT}"
309 + MY_LIBEXECDIR="${EPREFIX}/usr/libexec/wine-${WINE_VARIANT}"
310 + MY_LOCALSTATEDIR="${EPREFIX}/var/wine-${WINE_VARIANT}"
311 + MY_MANDIR="${MY_DATADIR}/man"
312 +}
313 +
314 +src_unpack() {
315 + if [[ ${PV} == "9999" ]] ; then
316 + EGIT_CHECKOUT_DIR="${S}" git-r3_src_unpack
317 + fi
318 +
319 + default
320 +
321 + l10n_find_plocales_changes "${S}/po" "" ".po"
322 +}
323 +
324 +src_prepare() {
325 +
326 + eapply_bin(){
327 + local patch
328 + for patch in ${PATCHES_BIN[@]}; do
329 + patchbin --nogit < "${patch}" || die
330 + done
331 + }
332 +
333 + local md5="$(md5sum server/protocol.def)"
334 +
335 + default
336 + eapply_bin
337 + eautoreconf
338 +
339 + # Modification of the server protocol requires regenerating the server requests
340 + if [[ "$(md5sum server/protocol.def)" != "${md5}" ]]; then
341 + einfo "server/protocol.def was patched; running tools/make_requests"
342 + tools/make_requests || die #432348
343 + fi
344 + sed -i '/^UPDATE_DESKTOP_DATABASE/s:=.*:=true:' tools/Makefile.in || die
345 + if ! use run-exes; then
346 + sed -i '/^MimeType/d' loader/wine.desktop || die #117785
347 + fi
348 +
349 + # Edit wine.desktop to work for specific variant
350 + sed -e "/^Exec=/s/wine /wine-${WINE_VARIANT} /" -i loader/wine.desktop || die
351 +
352 + # hi-res default icon, #472990, https://bugs.winehq.org/show_bug.cgi?id=24652
353 + cp "${PATCHDIR}/files/oic_winlogo.ico" dlls/user32/resources/ || die
354 +
355 + l10n_get_locales > po/LINGUAS || die # otherwise wine doesn't respect LINGUAS
356 +
357 + # Fix manpage generation for locales #469418 and abi_x86_64 #617864
358 +
359 + # Duplicate manpages input files for wine64
360 + local f
361 + for f in loader/*.man.in; do
362 + cp ${f} ${f/wine/wine64} || die
363 + done
364 + # Add wine64 manpages to Makefile
365 + if use abi_x86_64; then
366 + sed -i "/wine.man.in/i \
367 + \\\twine64.man.in \\\\" loader/Makefile.in || die
368 + sed -i -E 's/(.*wine)(.*\.UTF-8\.man\.in.*)/&\
369 +\164\2/' loader/Makefile.in || die
370 + fi
371 +
372 + rm_man_file(){
373 + local file="${1}"
374 + loc=${2}
375 + sed -i "/${loc}\.UTF-8\.man\.in/d" "${file}" || die
376 + }
377 +
378 + while read f; do
379 + l10n_for_each_disabled_locale_do rm_man_file "${f}"
380 + done < <(find -name "Makefile.in" -exec grep -q "UTF-8.man.in" "{}" \; -print)
381 +}
382 +
383 +src_configure() {
384 + wine_compiler_check || die
385 +
386 + export LDCONFIG=/bin/true
387 + use custom-cflags || strip-flags
388 +
389 + multilib-minimal_src_configure
390 +}
391 +
392 +multilib_src_configure() {
393 + local myconf=(
394 + --prefix="${MY_PREFIX}"
395 + --datarootdir="${MY_DATAROOTDIR}"
396 + --datadir="${MY_DATADIR}"
397 + --docdir="${MY_DOCDIR}"
398 + --includedir="${MY_INCLUDEDIR}"
399 + --libdir="${EPREFIX}/usr/$(get_libdir)/wine-${WINE_VARIANT}"
400 + --libexecdir="${MY_LIBEXECDIR}"
401 + --localstatedir="${MY_LOCALSTATEDIR}"
402 + --mandir="${MY_MANDIR}"
403 + --sysconfdir=/etc/wine
404 + $(use_with alsa)
405 + $(use_with capi)
406 + $(use_with lcms cms)
407 + $(use_with cups)
408 + $(use_with ncurses curses)
409 + $(use_with udisks dbus)
410 + $(use_with fontconfig)
411 + $(use_with ssl gnutls)
412 + $(use_enable gecko mshtml)
413 + $(use_with gphoto2 gphoto)
414 + $(use_with gsm)
415 + $(use_with gssapi)
416 + $(use_with gstreamer)
417 + --without-hal
418 + $(use_with jpeg)
419 + $(use_with kerberos krb5)
420 + $(use_with ldap)
421 + $(use_enable mono mscoree)
422 + $(use_with mp3 mpg123)
423 + $(use_with netapi)
424 + $(use_with nls gettext)
425 + $(use_with openal)
426 + $(use_with opencl)
427 + $(use_with opengl)
428 + $(use_with osmesa)
429 + $(use_with oss)
430 + $(use_with pcap)
431 + $(use_with png)
432 + $(use_with pulseaudio pulse)
433 + $(use_with threads pthread)
434 + $(use_with scanner sane)
435 + $(use_with sdl)
436 + $(use_enable test tests)
437 + $(use_with truetype freetype)
438 + $(use_with udev)
439 + $(use_with v4l)
440 + $(use_with vkd3d)
441 + $(use_with vulkan)
442 + $(use_with X x)
443 + $(use_with X xfixes)
444 + $(use_with xcomposite)
445 + $(use_with xinerama)
446 + $(use_with xml)
447 + $(use_with xml xslt)
448 + )
449 +
450 + local PKG_CONFIG AR RANLIB
451 + # Avoid crossdev's i686-pc-linux-gnu-pkg-config if building wine32 on amd64; #472038
452 + # set AR and RANLIB to make QA scripts happy; #483342
453 + tc-export PKG_CONFIG AR RANLIB
454 +
455 + if use amd64; then
456 + if [[ ${ABI} == amd64 ]]; then
457 + myconf+=( --enable-win64 )
458 + else
459 + myconf+=( --disable-win64 )
460 + fi
461 +
462 + # Note: using --with-wine64 results in problems with multilib.eclass
463 + # CC/LD hackery. We're using separate tools instead.
464 + fi
465 +
466 + ECONF_SOURCE=${S} \
467 + econf "${myconf[@]}"
468 + emake depend
469 +}
470 +
471 +multilib_src_test() {
472 + # FIXME: win32-only; wine64 tests fail with "could not find the Wine loader"
473 + if [[ ${ABI} == x86 ]]; then
474 + if [[ $(id -u) == 0 ]]; then
475 + ewarn "Skipping tests since they cannot be run under the root user."
476 + ewarn "To run the test ${MY_PN} suite, add userpriv to FEATURES in make.conf"
477 + return
478 + fi
479 +
480 + WINEPREFIX="${T}/.wine-${ABI}" \
481 + Xemake test
482 + fi
483 +}
484 +
485 +multilib_src_install_all() {
486 + local DOCS=( ANNOUNCE AUTHORS README )
487 + add_locale_docs() {
488 + local locale_doc="documentation/README.$1"
489 + [[ ! -e ${locale_doc} ]] || DOCS+=( ${locale_doc} )
490 + }
491 + l10n_for_each_locale_do add_locale_docs
492 +
493 + einstalldocs
494 + prune_libtool_files --all
495 +
496 + if ! use perl ; then # winedump calls function_grep.pl, and winemaker is a perl script
497 + rm "${D%/}${MY_PREFIX}"/bin/{wine{dump,maker},function_grep.pl} \
498 + "${D%/}${MY_MANDIR}"/man1/wine{dump,maker}.1 || die
499 + fi
500 +
501 + # Remove wineconsole if neither backend is installed #551124
502 + if ! use X && ! use ncurses; then
503 + rm "${D%/}${MY_PREFIX}"/bin/wineconsole* || die
504 + rm "${D%/}${MY_MANDIR}"/man1/wineconsole* || die
505 + rm_wineconsole() {
506 + rm "${D%/}${MY_PREFIX}/$(get_libdir)"/wine/{,fakedlls/}wineconsole.exe* || die
507 + }
508 + multilib_foreach_abi rm_wineconsole
509 + fi
510 +
511 + use abi_x86_32 && pax-mark psmr "${D%/}${MY_PREFIX}"/bin/wine{,-preloader} #255055
512 + use abi_x86_64 && pax-mark psmr "${D%/}${MY_PREFIX}"/bin/wine64{,-preloader}
513 +
514 + if use abi_x86_64 && ! use abi_x86_32; then
515 + dosym wine64 "${MY_PREFIX}"/bin/wine # 404331
516 + dosym wine64-preloader "${MY_PREFIX}"/bin/wine-preloader
517 + fi
518 +
519 + # Failglob for binloops, shouldn't be necessary, but including to stay safe
520 + eshopts_push -s failglob #615218
521 + # Make wrappers for binaries for handling multiple variants
522 + # Note: wrappers instead of symlinks because some are shell which use basename
523 + local b
524 + for b in "${D%/}${MY_PREFIX}"/bin/*; do
525 + make_wrapper "${b##*/}-${WINE_VARIANT}" "${MY_PREFIX}/bin/${b##*/}"
526 + done
527 + eshopts_pop
528 +}
529 +
530 +pkg_postinst() {
531 + eselect wine register ${P}
532 + if [[ ${PN} == "wine-vanilla" ]]; then
533 + eselect wine register --vanilla ${P} || die
534 + fi
535 +
536 + eselect wine update --all --if-unset || die
537 +
538 + xdg_desktop_database_update
539 +
540 + if ! use gecko; then
541 + ewarn "Without Wine Gecko, wine prefixes will not have a default"
542 + ewarn "implementation of iexplore. Many older windows applications"
543 + ewarn "rely upon the existence of an iexplore implementation, so"
544 + ewarn "you will likely need to install an external one, like via winetricks"
545 + fi
546 + if ! use mono; then
547 + ewarn "Without Wine Mono, wine prefixes will not have a default"
548 + ewarn "implementation of .NET. Many windows applications rely upon"
549 + ewarn "the existence of a .NET implementation, so you will likely need"
550 + ewarn "to install an external one, like via winetricks"
551 + fi
552 +}
553 +
554 +pkg_prerm() {
555 + eselect wine deregister ${P}
556 + if [[ ${PN} == "wine-vanilla" ]]; then
557 + eselect wine deregister --vanilla ${P} || die
558 + fi
559 +
560 + eselect wine update --all --if-unset || die
561 +}
562 +
563 +pkg_postrm() {
564 + xdg_desktop_database_update
565 +}